<?php
/**
 * KBoard 위젯 게시글 리스트
 * @link http://www.cosmosfarm.com
 * @copyright Copyright 2017 Cosmosfarm. All rights reserved.
 */

class KBoardWidgetList {
	
	public function getListResults($value, $limit, $exclude, $with_notice){
		global $wpdb;
		
		$where = array();
		$results = array();
		
		if($value != 'comment' && $value != 'my_comment'){
			// 제외할 게시판 아이디
			$exclude != ''?$where[] = "`board_id` NOT IN ({$exclude})":'';
			// 휴지통에 없는 게시글만 불러온다.
			$where[] = "(`status`='' OR `status` IS NULL OR `status`='pending_approval')";
			// 공지사항 포함 여부
			if($value != 'notice' && $with_notice != '1'){
				$where[] = "`notice`='' OR `notice` is NULL";
			}
		}
		else{
			// 제외할 게시판 아이디 (댓글)
			$exclude != ''?$where[] = "`content`.`board_id` NOT IN ({$exclude})":'';
			// 휴지통에 없는 게시글만 불러온다. (댓글)
			$where[] = "(`content`.`status`='' OR `content`.`status` IS NULL OR `content`.`status`='pending_approval')";
		}
		
		if($value == 'latest'){
			$where = implode(' AND ', $where);
			$results = $wpdb->get_results("SELECT `uid` FROM `{$wpdb->prefix}kboard_board_content` WHERE {$where} ORDER BY `date` DESC LIMIT {$limit}");
		}
		elseif($value == 'vote'){
			$where = implode(' AND ', $where);
			$results = $wpdb->get_results("SELECT `uid` FROM `{$wpdb->prefix}kboard_board_content` WHERE {$where} ORDER BY `vote` DESC, `date` DESC LIMIT {$limit}");
		}
		elseif($value == 'view'){
			$where = implode(' AND ', $where);
			$results = $wpdb->get_results("SELECT `uid` FROM `{$wpdb->prefix}kboard_board_content` WHERE {$where} ORDER BY `view` DESC, `date` DESC LIMIT {$limit}");
		}
		elseif($value == 'notice'){
			$where[] = "`notice`= 'true'";
			$where = implode(' AND ', $where);
			$results = $wpdb->get_results("SELECT `uid` FROM `{$wpdb->prefix}kboard_board_content` WHERE {$where} ORDER BY `date` DESC LIMIT {$limit}");
		}
		elseif($value == 'my_post'){
			if(is_user_logged_in()){
				$where[] = "`member_uid`=" . get_current_user_id();
				$where = implode(' AND ', $where);
				$results = $wpdb->get_results("SELECT `uid` FROM `{$wpdb->prefix}kboard_board_content` WHERE {$where} ORDER BY `date` DESC LIMIT {$limit}");
			}
		}
		elseif($value == 'comment'){
			$where[] = '1';
			$where = implode(' AND ', $where);
			$results = $wpdb->get_results("SELECT `comment`.`uid` FROM `{$wpdb->prefix}kboard_comments` AS `comment` INNER JOIN `{$wpdb->prefix}kboard_board_content` AS `content` on `content`.`uid` = `comment`.`content_uid` WHERE {$where} ORDER BY `created` DESC LIMIT {$limit}");
		}
		elseif($value == 'my_comment'){
			$where[] = '1';
			if(is_user_logged_in()){
				$where[] = "`user_uid`=" . get_current_user_id();
				$where = implode(' AND ', $where);
				$results = $wpdb->get_results("SELECT `comment`.`uid` FROM `{$wpdb->prefix}kboard_comments` AS `comment` INNER JOIN `{$wpdb->prefix}kboard_board_content` AS `content` on `content`.`uid` = `comment`.`content_uid` WHERE {$where} ORDER BY `created` DESC LIMIT {$limit}");
			}
		}
		
		if($results){
			foreach($results as $key=>$row){
				$url = new KBUrl();
				
				if($value != 'comment' && $value != 'my_comment'){
					$content = new KBContent();
					$content->initWithUID($row->uid);
					$content->url = $url->getDocumentRedirect($content->uid);
					$content->row_type = 'content';
					$results[$key] = $content;
				}
				else{
					$comment = new KBcomment();
					$comment->initWithUID($row->uid);
					$comment->url = $url->getDocumentRedirect($comment->content_uid);
					
					// 최신댓글 View에서 게시물이 비밀글인지
					$content = new KBContent();
					$content->initWithUID($comment->content_uid);
					$comment->secret = $content->secret;
					
					$notify_time = kboard_new_document_notify_time();
					if((current_time('timestamp')-strtotime($comment->created)) <= $notify_time && $notify_time != '1'){
						$comment->is_new = true;
					}
					else{
						$comment->is_new = false;
					}
					
					if(date('Ymd', current_time('timestamp')) == date('Ymd', strtotime($comment->created))){
						$comment->created = date('H:i', strtotime($comment->created));
					}
					else{
						$comment->created = date('Y.m.d', strtotime($comment->created));
					}
					
					$comment->row_type = 'comment';
					$results[$key] = $comment;
				}
			}
			return $results;
		}
		return '';

	} // end function
	
} // end class
?>